
#define MLD_OK           0
#define MLD_PARAM_ERR    -1



//====================== T6X specific pars ==============================

#define  T6X_M_ID       0x101       // T6x Device ID
#define  T6X_PRG_ID     0x100       // this program ID


#define  MSTAT_RDY      0L
#define  MSTAT_BUSY     1L
#define  MSTAT_ATTN     2L
#define  MSTAT_GO       3L
#define  MSTAT_ABORT    4L

#define  MERR_OK        0L
#define  MERR_INV_CMND  1L


#define  MCMND_DAS_DAC_SCAN    0x101L    // DAS scan with DAC output
#define  MCMND_ADC_TO_DAC 	0x103L



struct MCD_DD            // Master Communication Descriptor
 { long m_id;            // Master ID
   long prg_id;          // Master program ID

   long status;          // Master STATUS: MSTAT_RDY/BUSY/ATTN
   long err;             // command exec error

   long cmnd;            // command to exec
   long fq;		// unused
   long epoch_len;       // epoch length
   long adc_data_saddr,  // ADC data buffer start
        dac_data_saddr;  // DAC data sptr

   long mode;            // ASYNC (==0) or SYXN (==1) mode
   long fs_sel;          // Fs Selector (0 - FSG, 1- Ext Fs,
   			//               2 -SIOX TM-0, 3 - FSX (ASYNC mode only)
   long fs;		// Fs value (in Hz)

   long ad_chan;         // A/D channels (bits 0..3)
   long da_chan;         // D/A channels (bits 0..3)

   long ad_chan_total;   // total number of A/D channels
   long da_chan_total;   // total number of D/A channels
   long synclk_sel; // synchro-clock source
 };


#define  MCD_SADDR      (0x200L)   // MCD & MDATA SBUS addr

//========================================================================
