/*********************************************************************
  T/SDAS-ADDA4/16Q/200K SIOX DCM definitions for C3x/C6x DSP. Rev.1C
  (C) MicroLAB Systems Ltd, 1998-2002

  Notes:
    1. This file must be used as .H header file for 32-bit
       C3x/C6x DSP environments of host TORNADO DSP system or
       controller.

**********************************************************************/


//=================== CONTROL MODE defs =================

	//~~~~~~~~~~~ commands ~~~~~~~~~~~~~~
#define	TSDAS_ADDA4_CTRL_RG_WR_CMND			0x0000
#define	TSDAS_ADDA4_FSG_RG0_WR_CMND			0x8000
#define	TSDAS_ADDA4_FSG_RG1_WR_CMND			0x8100
#define	TSDAS_ADDA4_FSG_RG2_WR_CMND			0x8200


	//~~~~~~~~~~~ CONTROL RG bits ~~~~~~~~~~~~
#define TSDAS_ADDA4_CTRL_RG_ADC0_EN			0x0001
#define TSDAS_ADDA4_CTRL_RG_ADC1_EN			0x0002
#define TSDAS_ADDA4_CTRL_RG_ADC2_EN			0x0004
#define TSDAS_ADDA4_CTRL_RG_ADC3_EN			0x0008
#define TSDAS_ADDA4_CTRL_RG_DAC0_EN			0x0010
#define TSDAS_ADDA4_CTRL_RG_DAC1_EN			0x0020
#define TSDAS_ADDA4_CTRL_RG_DAC2_EN			0x0040
#define TSDAS_ADDA4_CTRL_RG_DAC3_EN			0x0080

#define TSDAS_ADDA4_CTRL_RG_ASYNC_MODE		0x0000
#define TSDAS_ADDA4_CTRL_RG_SYNC_MODE		0x0100

#define TSDAS_ADDA4_CTRL_RG_FS_SEL_FSG		0x0000
#define TSDAS_ADDA4_CTRL_RG_FS_SEL_XFS		0x0200
#define TSDAS_ADDA4_CTRL_RG_FS_SEL_SXTM		0x0400
#define TSDAS_ADDA4_CTRL_RG_FS_SEL_SXFSX	0x0600

#define TSDAS_ADDA4_CTRL_RG_SDW_FMT64		0x0000
#define TSDAS_ADDA4_CTRL_RG_SDW_FMT32		0x0800
#define TSDAS_ADDA4_CTRL_RG_SDW_FMT16		0x1000

#define TSDAS_ADDA4_CTRL_RG_CLK_SEL_ONBOARD	0x0000
#define TSDAS_ADDA4_CTRL_RG_CLK_SEL_SXCLKX	0x2000


	//~~~~~~~~~~~ FSG RG0..2 bits ~~~~~~~~~~~~
#define TSDAS_ADDA4_FSG_RG_BITMASK			0x00ff

#define TSDAS_ADDA4_FSG_RG0_DEFAULT			0x0031
#define TSDAS_ADDA4_FSG_RG1_DEFAULT			0x0000
#define TSDAS_ADDA4_FSG_RG2_DEFAULT			0x0000

#define TSDAS_ADDA4_FSG_CLKIN_FREQ			10000000L


	//~~ internal CLKX frequency and recommended external CLK freq value
#define TSDAS_ADDA4_CLKX_FREQ				15000000L



//=============== SIO port configuration =====================

//~~~~~~recommended configurations for 60MHz C3x DSP ~~~~~~~~

	// CONTROL MODE:
	//       XLen=Rlen=16bits
	//       XCLK - Int,  RCLK - Ext
	//       FSX - output, HS=0, XVAREN=RVAREN=0, XFSM=RFSM=0
	//       CLKXP - active high, CLKRP - active high,
	//       FSXP=FSRP - active low (1)
	//
	// DATA MODE:
	//       XLen=Rlen=16bits
	//       XCLK - Ext,  RCLK - Ext
	//       FSX - input, HS=0, XVAREN=RVAREN=0, XFSM=RFSM=0
	//       CLKXP - active high, CLKRP - active high,
	//       FSXP=FSRP - active low (1)

	// GCR-CMODE: 0000 0000 0001 0111 0000 0000 0100 0100
	// GCR-DMODE: 0000 0000 0001 0111 0000 0000 0100 0100

#define	TSDAS_ADDA4_C3X_SIO_GCRG_DATA_CMODE	0x00170044
#define	TSDAS_ADDA4_C3X_SIO_GCRG_DATA_DMODE	0x00170000

#define	TSDAS_ADDA4_C3X_SIO_GCRG_GO_MASK	0x0c000000
#define	TSDAS_ADDA4_C3X_SIO_XCRG_DATA		0x111
#define	TSDAS_ADDA4_C3X_SIO_RCRG_DATA		0x111

#define TSDAS_ADDA4_C3X_SIO_RXTCRG_DATA		0x8
#define TSDAS_ADDA4_C3X_SIO_RXTCRG_GO_MASK	0x3
#define TSDAS_ADDA4_C3X_SIO_RXTPERRG_DATA	0x1


//~~~~~~~ recommended configuration for different C6x DSPs:
//	(C6201@200MHz, C6202@250MHz, C6203@300MHz, C6701@167MHz, C64xx@600MHz/720MHz/1GHz)
	// CONTROL MODE:
	//       XLen=Rlen=16bits
	//       CLKX - Int,  CLKR - Ext
	//       FSX - output on DX load event, FSR - input
	//       CLKXP - active high, CLKRP - active high,
	//       FSXP=FSRP - active low (1)
	//	 	 CLKX = 10MHz

	// DATA MODE:
	//       XLen=Rlen=32bits, 2 words/frame
	//       XCLK - ext,  RCLK - Ext
	//       FSX - input, FSR - input
	//       CLKXP - active high, CLKRP - active high,
	//       FSXP=FSRP - active low (1)
	//	 	 CLKX (when generated by DSP) = approx 15MHz

	// SPCR:		0000 0000 0000 0000 0000 0000 0000 0000
	// PCR-CMODE:	0000 0000 0000 0000 0000 1010 0000 1100
	// PCR-DMODE:	0000 0000 0000 0000 0000 0000 0000 1100
	// X/RCR-CMODE: 0000 0000 0000 0001 0000 0000 0100 0000
	// X/RCR-DMODE: 0000 0000 0000 0001 0000 0001 1010 0000
	// SRGR: 		0010 0000 0000 0000 0000 0000 0001 0100

#define	TSDAS_ADDA4_C6X_MCBSP_SPCR_DATA			0x00000000
#define	TSDAS_ADDA4_C6X_MCBSP_PCR_DATA_CMODE	0x00000a0c
#define	TSDAS_ADDA4_C6X_MCBSP_PCR_DATA_DMODE	0x0000000c
#define	TSDAS_ADDA4_C6X_MCBSP_XRCR_DATA_CMODE	0x00010040
#define	TSDAS_ADDA4_C6X_MCBSP_XRCR_DATA_DMODE	0x000101a0

#define	TSDAS_ADDA4_C6201_MCBSP_SRGR_DATA_CMODE	0x20000014
#define	TSDAS_ADDA4_C6701_MCBSP_SRGR_DATA_CMODE	0x20000015
#define	TSDAS_ADDA4_C6202_MCBSP_SRGR_DATA_CMODE	0x20000018
#define	TSDAS_ADDA4_C6203_MCBSP_SRGR_DATA_CMODE	0x2000001d
#define	TSDAS_ADDA4_C64XX_600MHZ_MCBSP_SRGR_DATA_CMODE	0x2000000e
#define	TSDAS_ADDA4_C64XX_720MHZ_MCBSP_SRGR_DATA_CMODE	0x20000011
#define	TSDAS_ADDA4_C64XX_1000MHZ_MCBSP_SRGR_DATA_CMODE	0x20000018

#define	TSDAS_ADDA4_C6201_MCBSP_SRGR_DATA_DMODE	0x3000000d
#define	TSDAS_ADDA4_C6202_MCBSP_SRGR_DATA_DMODE	0x30000010
#define	TSDAS_ADDA4_C6203_MCBSP_SRGR_DATA_DMODE	0x30000013
#define	TSDAS_ADDA4_C6701_MCBSP_SRGR_DATA_DMODE	0x3000000a			// approx 15.18MHz
#define	TSDAS_ADDA4_C64XX_600MHZ_MCBSP_SRGR_DATA_DMODE	0x30000009
#define	TSDAS_ADDA4_C64XX_720MHZ_MCBSP_SRGR_DATA_DMODE	0x3000000b
#define	TSDAS_ADDA4_C64XX_1000MHZ_MCBSP_SRGR_DATA_DMODE	0x30000010	// approx 14.7MHz

#define	TSDAS_ADDA4_C6X_MCBSP_SRGR_FPER_BITMASK	0x0fff0000
#define	TSDAS_ADDA4_C6X_MCBSP_SRGR_FPER_SHIFT	16

#define	TSDAS_ADDA4_C6X_MCBSP_SPCR_GO_MASK		0x00c10001

#define	TSDAS_ADDA4_C6X_MCBSP_PCR_DMODE_XFSX	0x00000000
#define	TSDAS_ADDA4_C6X_MCBSP_PCR_DMODE_IFSX	0x00000800
#define	TSDAS_ADDA4_C6X_MCBSP_PCR_DMODE_XCLKX	0x00000000
#define	TSDAS_ADDA4_C6X_MCBSP_PCR_DMODE_ICLKX	0x00000200

//===========================================================
